<?php

function db_connect()
{
  global $db;

  $dsn = sprintf('%s:host=%s;dbname=%s', DBDRIVER, DBHOST, DBNAME);
  $db = new Database(DBDRIVER, DBHOST, DBNAME, DBUSER, DBPASS);
  if (defined('MAIL_ERROR')) $db->setErrorMail(MAIL_ERROR);
}

function db_error()
{
  global $db;

  $info = $db->errorInfo();

  return $info[2];
}

function db_lastid($table)
{
  global $db;

  return $db->lastInsertId();
}

function query_db($sql)
{
  global $db;

  $sth = $db->query($sql);

  if ($sth === false) return false;

  $result = array();
  while ($row = $sth->fetch())
    $result[] = $row;

  return $result;
}

function db_format_datetime($col)
{
  if (DBDRIVER == 'pgsql')
    return sprintf("to_char(%s,'DD.MM.YYYY HH24:mm')", $col);
  elseif (DBDRIVER == 'mysql')
    return sprintf("date_format(%s,'%%e.%%m.%%Y %%H:%%i')", $col);
  else
    die("Unsupported database driver");
}

function db_format_date($col)
{
  if (DBDRIVER == 'pgsql')
    return sprintf("to_char(%s,'DD.MM.YYYY')", $col);
  elseif (DBDRIVER == 'mysql')
    return sprintf("date_format(%s,'%%e.%%m.%%Y')", $col);
  else
    die("Unsupported database driver");
}

?>