<?php

define('STATUS_DEFUNCT', 3);

$style[] = <<<EOC
div#form_screw, div#form_decommission {
  padding-left: 10px;
  padding-right: 10px;
  font-size: 90%;
  color: #555;
}
EOC;

$form = '
<div id="form_screw">
<form>
<input id="form_component" name="component" type="hidden" />
<label for="form_compound">Verbund</label><br>
<select id="form_compound" name="compound">
<option value="">...</option>
</select>
<br>
<label for="form_starttime">Von</label><br>
<input id="form_starttime" name="starttime" size="8">&nbsp;<img class="calendar" src="images/icons/calendar.gif" onclick="calendar(\\\'form_starttime\\\',event)" />
<br>
<label for="form_endtime">Bis</label><br>
<input id="form_endtime" name="endtime" size="8">&nbsp;<img class="calendar" src="images/icons/calendar.gif" onclick="calendar(\\\'form_endtime\\\',event)" />
<br>
<label for="form_usage">Verwendung</label><br>
<input id="form_usage" name="usage" size="23">
<div class="buttons" style="margin-top: 15px;">
<button onclick="return screw_add(this);">Verbinden</button>
</div>
</form>
</div>
<div id="form_decommission">
<form>
<input id="form_component2" name="component" type="hidden" />
<label for="form_termtime">Datum</label><br>
<input id="form_termtime" name="termtime" size="8">&nbsp;
<img class="calendar" src="images/icons/calendar.gif" onclick="calendar(\\\'form_termtime\\\',event)" />
<br><label for="form_termcomment">Bemerkung</label><br>
<textarea id="form_termcomment" name="comment" cols="26" rows="5">
</textarea>
<div class="buttons" style="margin-top: 15px;">
<button onclick="return decommission_component(this);">Stillegen</button>
</div>
</form>
</div>
';

$javascript = <<<EOC
var screw_popup = false;
function screw_popup_open(visibleId, hiddenId)
{
    if (!screw_popup) {
	var options = { hideOnClick: false, canDragFunc: true };
	var content = 'CONTENT_FORM';

	screw_popup = new Rico.Popup(options, false, false);
	screw_popup.createWindow('<strong>Verbinden</strong>',content,'auto','200px');
    }

    var name = document.getElementById('edit_name');
    if (name.value.length)
	screw_popup.titleDiv.childNodes[0].innerHTML = name.value;
    else
	screw_popup.titleDiv.childNodes[0].innerHTML = 'Verbinden';

    var form_id = document.getElementById('edit_id');
    var component = document.getElementById('form_component');
    var component2 = document.getElementById('form_component2');
    component.value = form_id.value;
    component2.value = form_id.value;

    var formDiv = document.getElementById(visibleId);
    formDiv.style.display = '';
    formDiv = document.getElementById(hiddenId);
    formDiv.style.display = 'none';

    screw_popup.openPopup(100,300);
}

function screw_this()
{
    var eid = document.getElementById('edit_id');
    if (!eid || !eid.value.length) return false;

    screw_popup_open('form_screw','form_decommission');
    return false;
}

function screw_callback(data)
{
    info('Verbindung gespeichert');
    grid_update(second);
}

function screw_add(obj)
{
    screw_popup.closePopup();

    var compound = document.getElementById('form_compound');
    if (!compound.options[compound.selectedIndex].value.length) {
	error('Kein Verbund ausgwählt');
	return false;
    }

    var starttime = document.getElementById('form_starttime');
    if (!starttime.value.length) {
	error('Keine Anfangszeit angegeben');
	return false;
    }

    var source = document.getElementById('source');
    if (!source) return false;

    var parms = 'source=' + source.innerHTML + '&callback=screw&';
    ajax_request('function', parms+Form.serialize(obj.form), screw_callback);

    starttime.value = '';

    return false;
}

function decommission_callback(data)
{
    var name = document.getElementById('edit_name');
    if (name.value.length)
        info(name.value + ' stillgelegt');

    grid_update(grid);
    grid_update(second);
}

function decommission_component(obj)
{
    screw_popup.closePopup();

    var termtime = document.getElementById('form_termtime');
    if (!termtime.value.length) {
	error('Keine Endzeit angegeben');
	return false;
    }

    var source = document.getElementById('source');
    if (!source) return false;

    var parms = 'source=' + source.innerHTML + '&callback=decommission&';
    ajax_request('function', parms+Form.serialize(obj.form), decommission_callback);

    termtime.value = '';

    return false;
}

function decommission()
{
    var eid = document.getElementById('edit_id');
    if (!eid || !eid.value.length) return false;

    screw_popup_open('form_decommission','form_screw');
    return false;
}

EOC;

$options = '<option value="">...</option>';
if ($_GET['mask'] == 'hardware__component') {
    $compounds = query_db("SELECT id,name FROM hw_compound ORDER BY name");
    foreach ($compounds as $row) {
	$options .= sprintf('<option value="%d">%s</option>', $row['id'], $row['name']);
    }
}

$jscode[] = str_replace('CONTENT_FORM', str_replace(array('<option value="">...</option>',"\n"),
						    array($options,"\\\n"), $form), $javascript);

$buttons = <<<EOC
<p style="margin-top: 0px; margin-bottom: 4px; text-align: center;">
<button onclick="return screw_this()">Verbinden</button>
&nbsp;
<button onclick="return decommission()">Stillegen</button>
</p>
EOC;

$mask = array(
	      'table' => 'hw_component',
	      'title' => 'Komponenten',
	      'list' => array(
			      'id' => array(
					    'name' => 'ID',
					    'visible' => false,
					    ),
			      'hwtype' => array(
					    'name' => 'Typ',
					    'width' => 90,
					    'specs' => "ClassName: 'aligncenter', filterUI: 's'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('hw_types','id','name').", 0, '')",
					    'distinct' => "SELECT DISTINCT hwtype,hw_types.name FROM hw_component JOIN hw_types ON hwtype = hw_types.id ORDER BY name",
					    ),
			      'name' => array(
					    'name' => 'Name',
					    'width' => 230,
					    'specs' => "filterUI: 't'",
					    ),
			      'serno' => array(
					    'name' => 'Serial',
					    'width' => 180,
					    'visible' => false,
					    ),
			      'price' => array(
					    'name' => 'Preis',
					    'width' => 50,
					    'specs' => "decPlaces: 2, ClassName: 'alignrightpad', canSort: false",
					    ),
			      'owner' => array(
					    'name' => 'Eigner',
					    'width' => 55,
					    'specs' => "ClassName: 'aligncenter', filterUI: 's'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('hw_organisation','id','name').", 0, '')",
					    'distinct' => "SELECT DISTINCT owner,hw_organisation.name FROM hw_component JOIN hw_organisation ON owner = hw_organisation.id ORDER BY name",
					    ),
			      'starttime' => array(
					    'name' => 'Start',
					    'width' => 75,
					    ),
			      'endtime' => array(
					    'name' => 'End',
					    'width' => 75,
					    ),
			      'status' => array(
					    'name' => 'Status',
					    'width' => 50,
					    'specs' => "filterUI: 's'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('hw_status','id','name').", 0, '')",
					    'distinct' => "SELECT DISTINCT status,hw_status.name FROM hw_component JOIN hw_status ON owner = hw_status.id ORDER BY name",
					    ),
			      ),
	      'edit' => array(
			      'hwtype' => array(
					    'name' => 'Typ',
					    'type' => 'select',
					    'options' => 'SELECT id,name AS text FROM hw_types ORDER BY name',
					    ),
			      'name' => array(
					    'name' => 'Name',
					    'type' => 'text',
					    'size' => 25,
					    ),
			      'serno' => array(
					    'name' => 'Serial Number',
					    'type' => 'text',
					    'size' => 20,
					    ),
			      'price' => array(
					    'name' => 'Preis',
					    'type' => 'decimal',
					    'size' => 10,
					    ),
			      'owner' => array(
					    'name' => 'Besitzer',
					    'type' => 'select',
					    'options' => 'SELECT id,name AS text FROM hw_organisation ORDER BY name',
					    ),
			      'starttime' => array(
					    'name' => 'Von',
					    'type' => 'date',
					    'size' => 8,
					    ),
			      'endtime' => array(
					    'name' => 'Bis',
					    'type' => 'date',
					    'size' => 8,
					    'null' => true,
					    ),
			      'status' => Array(
					    'name' => 'Status',
					    'type' => 'select',
					    'options' => 'SELECT id,name AS text FROM hw_status ORDER BY id',
					    ),
			      'comment' => array(
					    'name' => 'Bemerkung',
					    'type' => 'textarea',
					    ),
			      'screw' => array(
					    'type' => 'html',
					    'code' => $buttons,
					    'sql' => false,
					    ),
			      ),
	      'callbacks' => array(
				   'screw' => cb_screw,
				   'decommission' => cb_decommission,
				),
	      'second' => array(
			'title' => 'Verwendung',
			'table' => 'hw_screw',
			'rows' => 10,
			'join' => array(
					'hw_compound ON compound = hw_compound.id',
					),
			'where' => 'component = {id} ORDER BY starttime',
			'list' => array(
			      'id' => array(
					    'name' => 'ID',
					    'visible' => false,
					    'sql' => 'hw_screw.id',
					    ),
			      'compound' => array(
					    'name' => 'Verbund',
					    'width' => 180,
					    'sql' => 'hw_compound.name',
					    ),
			      'starttime' => array(
					    'name' => 'Von',
					    'type' => 'date',
					    'width' => 80,
					    'sql' => 'hw_screw.starttime'
					    ),
			      'endtime' => array(
					    'name' => 'Bis',
					    'type' => 'date',
					    'width' => 80,
					    'sql' => 'hw_screw.endtime'
					    ),
			      'usage' => array(
					    'name' => 'Verwendung',
					    'width' => 270,
					    ),
				   ),
			      ),
	      );

function cb_screw()
{
  global $db;

  if (empty($_POST['component']) || empty($_POST['compound']) || empty($_POST['starttime']))
    return array('error' => 'Insufficient data transmitted');

  $starttime = format_date($_POST['starttime']);

  $sql = sprintf("SELECT id,compound,endtime FROM hw_screw WHERE component = %d AND starttime < '%s'::date ORDER BY starttime DESC LIMIT 1",
		 $_POST['component'], $starttime);

  $sth = $db->query($sql);

  $row = false;
  if ($sth !== false)
    $row = $sth->fetch();

  if ($row !== false) {
    if (empty($row['endtime'])) {
      $sql = sprintf("UPDATE hw_screw SET endtime='%s',sys_edit=now(),sys_user=%s WHERE id = %d",
		     $starttime,
		     $db->quote($_SESSION['sys']['login']), $row['id']);
      $db->query($sql);
    }
  }

  $usage = 'NULL';
  if (!empty($_POST['usage']))
    $usage = $db->quote($_POST['usage']);

  $endtime = 'NULL';
  if (!empty($_POST['endtime']))
    $endtime = "'" . format_date($_POST['endtime']) . "'";

  $sql = sprintf("INSERT INTO hw_screw (component,compound,usage,starttime,endtime,sys_user,sys_edit) " .
		 "VALUES (%d,%d,%s,'%s',%s,%s,now())",
		 $_POST['component'], $_POST['compound'],
		 $usage,
		 $starttime, $endtime,
		 $db->quote($_SESSION['sys']['login']));
  $db->query($sql);

  return true;
}

function cb_decommission()
{
  global $db;

  if (empty($_POST['component']) || empty($_POST['termtime']))
    return array('error' => 'Insufficient data transmitted');

  $termtime = format_date($_POST['termtime']);

  $sql = sprintf("SELECT id,endtime FROM hw_screw WHERE component = %d AND starttime < '%s'::date ORDER BY starttime DESC LIMIT 1",
		 $_POST['component'], $termtime);

  $sth = $db->query($sql);

  $row = false;
  if ($sth !== false)
    $row = $sth->fetch();

  if ($row !== false && empty($row['endtime'])) {
    $sql = sprintf("UPDATE hw_screw SET endtime='%s',sys_edit=now(),sys_user=%s WHERE id = %d",
		   $termtime,
		   $db->quote($_SESSION['sys']['login']), $row['id']);
    $db->query($sql);

  }

  if (!empty($_POST['comment'])) {
    $sql = sprintf("SELECT comment FROM hw_component WHERE id = %d", $_POST['component']);

    $sth = $db->query($sql);

    if ($sth !== false) {
      $row = $sth->fetch();
      if (!empty($row['comment']))
	$_POST['comment'] = $row['comment'] . "\n\n" . $_POST['comment'];
    }

    $sql = sprintf("UPDATE hw_component SET comment=%s WHERE id = %d",
		   $db->quote($_POST['comment']),
		   $_POST['component']);
    $db->query($sql);
  }


  $sql = sprintf("UPDATE hw_component SET endtime='%s',status=%d,sys_edit=now(),sys_user=%s WHERE id = %d",
		 $termtime, STATUS_DEFUNCT,
		 $db->quote($_SESSION['sys']['login']),
		 $_POST['component']);
  $db->query($sql);

  return true;
}

?>
